<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="distributionStatus" slot-scope="scope">
        <div v-if="scope.row.distributionStatus=0">配送中</div>
        <div v-if="scope.row.distributionStatus=1">已完成</div>
      </template>
      <template slot="userInfo" slot-scope="scope">
        <div style="display: flex;">
          <div style="display: flex;justify-content: center;align-items: center;">
            <el-avatar size="large" :src="scope.row.avatar"></el-avatar>
          </div>
           <div style="padding: 10px;">
             <div >昵称：{{scope.row.nickName}}</div>
             <div>手机：{{scope.row.phone}}</div>
           </div>
        </div>
      </template>

      <template slot="distributionStatus" slot-scope="scope">
        <el-tag type="warning" v-if="scope.row.distributionStatus==0">配送中</el-tag>
        <el-tag type="success" v-if="scope.row.distributionStatus==1">已完成</el-tag>
      </template>
      
      <template slot="distributionInfo" slot-scope="scope">
        <el-tag type="warning" v-if="scope.row.distributionStatus==0">配送中</el-tag>
        <el-tag type="success" v-if="scope.row.distributionStatus==1">已完成</el-tag>
      </template>
      
      
      
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.goodsrecord_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/goodsrecord/goodsrecord";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "用户id",
              hide:true,
              prop: "userId",
              rules: [{
                required: true,
                message: "请输入用户id",
                trigger: "blur"
              }]
            },
            {
              labal:"用户信息",
              width:200,
              slot:true,
              prop:"userInfo"
            },
            {
              label: "实物id",
              hide:true,
              prop: "goodsId",
              rules: [{
                required: true,
                message: "请输入实物id",
                trigger: "blur"
              }]
            },
            {
              label: "实物名称",
              prop: "goodsName",
              rules: [{
                required: true,
                message: "请输入实物名称",
                trigger: "blur"
              }]
            },
            {
              label:"昵称",
              search:true,
              hide:true,
              prop:"nickName"
            },
            {
              label:"手机号",
              search:true,
              hide:true,
              prop:"phone"
            },
            {
              label: "实物图片",
              prop: "goodsPic",
              slot:true,
              listType: 'picture-img',
              action: '/api/putObject',
              type: 'upload',
              propsHttp: {
                url: 'data'
              },
              rules: [{
                required: true,
                message: "请输入实物图片",
                trigger: "blur"
              }]
            },
            {
              label: "领取数量",
              prop: "count",
              rules: [{
                required: true,
                message: "请输入领取数量",
                trigger: "blur"
              }]
            },
            {
              label: "实物包邮的数量",
              hide:true,
              prop: "goodsPostAmount",
              rules: [{
                required: true,
                message: "请输入实物包邮的数量",
                trigger: "blur"
              }]
            },
            {
              label: "配送方式id,包邮则传-1",
              hide:true,
              prop: "distributionId",
              rules: [{
                required: true,
                message: "请输入配送方式id,包邮则传-1",
                trigger: "blur"
              }]
            },
            {
              label: "配送状态",
              search:true,
              prop: "distributionStatus",
              type: "select",
              dicData:[
                {
                  label:'配送中',
                  value:0
                },
                {
                  label:'已完成',
                  value:1
                }
              ],
              rules: [{
                required: true,
                message: "请输入配送状态,0: 配送中 1：已完成",
                trigger: "blur"
              }]
            },
            {
              label: "完成时间",
              hide:true,
              prop: "doneTime",
              rules: [{
                required: true,
                message: "请输入完成时间",
                trigger: "blur"
              }]
            },
            {
              label: "关联的地址",
              hide:true,
              prop: "addressId",
              rules: [{
                required: true,
                message: "请输入关联的地址",
                trigger: "blur"
              }]
            },
            {
              label:"配送信息",
              slot:true,
              prop:"distributionInfo"
            }
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.goodsrecord_add, false),
          viewBtn: this.vaildData(this.permission.goodsrecord_view, false),
          delBtn: this.vaildData(this.permission.goodsrecord_delete, false),
          editBtn: this.vaildData(this.permission.goodsrecord_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
